#include <iostream>
#include <iomanip>
#include "dllclass.h"
#include "cdll.h"

using namespace std;

extern DllClass global_dllclass1;
extern DllClass global_dllclass2;
extern int global_int_variable;

int main () { 
  cout 
    << "Global integer variable = " << global_int_variable << endl
    << "DllClass 1 (Imported from DLL):" << endl
      << "  virtual_method = " << global_dllclass1.virtual_method () << endl
      << "  non_virtual_method = " << global_dllclass1.non_virtual_method () 
        << endl
      << "  instances = " << global_dllclass1.instances << endl
    << "DllClass 2 (Imported from DLL):" << endl
      << "  virtual_method = " << global_dllclass2.virtual_method () << endl
      << "  non_virtual_method = " << global_dllclass2.non_virtual_method () 
        << endl
      << "  instances = " << global_dllclass2.instances << endl;

  DllClass local_dllclass (3);
  cout
    << "DllClass (Local):" << endl
      << "  virtual_method = " << local_dllclass.virtual_method () << endl
      << "  non_virtual_method = " << local_dllclass.non_virtual_method () 
        << endl
      << "  instances = " << DllClass::instances << endl;
  cout << setiosflags(ios::fixed) << setprecision(6) << endl;
  cout << "dll_int_square (3) = " <<  dll_int_square (3) << endl;
  cout << "dll_float_square (3.0) = " << dll_float_square (3.0) << endl;
  cout << "dll_double_square (3.0) = " << dll_double_square (3.0) << endl;
  cout << "Global integer variable: Should be 99" << endl;
  cout << "  directly                  : " << dll_global_int_var << endl;
  cout << "  via DLL accessor function : " << dll_get_global_int_var () << endl;
  cout << "Global integer variable: Setting value to -31 directly" << endl;
  dll_global_int_var = -31;
  cout << "Global integer variable:" << endl;
  cout << "  directly                  : " << dll_global_int_var << endl;
  cout << "  via DLL accessor function : " << dll_get_global_int_var () << endl;
  cout << "Global integer variable: Setting value to 27 in-directly" << endl;
  dll_set_global_int_var (27);
  cout << "Global integer variable:" << endl;
  cout << "  directly                  : " << dll_global_int_var << endl;
  cout << "  via DLL accessor function : " << dll_get_global_int_var () << endl;
  return 0;


  return 0;
}

